/*
    Stream Capture
    Copyright (C) 2011 Ingemar Ceicer
    http://ceicer.org/ingemar/
    programmering1 (at) ceicer (dot) org

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
*/


#include "config2.h"
#include "streamcapture.h"
#include<fstream>
#include<string>
#include<vector>
#include<iostream>



QString configure_path2 = QDir::toNativeSeparators(QDir::homePath()+"/."+ APPLICATION_NAME);


string my_configure_path2 = configure_path2.toStdString();



using namespace std;

Config2::Config2()
{


}

Config2::Config2(QString namn)
{
    //Lser in configurationsfilen i minnet
    //vid skapandet

    namn=namn.trimmed();

    //Hela skvgen
    QString configure = configure_path2 + QDir::toNativeSeparators(namn);
    string configure_s = configure.toStdString();
    conf_file = new string;
    *conf_file = configure_s;
    cr = new Createuser;


    checkConf(configure_s);
    readConf(configure_s);

    delete cr;
}



Config2::~Config2()
{
    //Skriver configurationsfilen innan dden
    writeConf();
}
/*
void Config2::deleteConf(int index)
{
    //Tar bort configurationen index "index"
    name_values->erase (name_values->begin()+index);



}
*/

bool Config2::newFile(vector<string> *vkt, string *filnamn)
{
    ofstream utfil;
    string hela;
    utfil.open (filnamn->c_str(),ios::out);
    if (!(utfil.is_open()))
    {
        return false;
    }
    utfil.clear();
    sort(vkt->begin(),vkt->end());
    vector<string>::reverse_iterator rit;
    for (rit=vkt->rbegin() ; rit < vkt->rend(); ++rit)
    {



              utfil << *rit;
              utfil << "\n";



    }
    utfil.close();
    return true;
}

void Config2::deleteConf2(string name)
{

    vector<string>::iterator it;
    string s;
    size_t pos0;
    pos0 = name.find("#");
    if (pos0 > 0)
       name = name.substr(0,pos0);

    for (it=name_values->begin();it<name_values->end();it++)
        {

                if (it->substr(0,1) != "#") // hoppa ver kommaterade rader direkt
                {
                    // Sker efter samma delstrng som skickas hit med samma lngd
                    // som hitskickade strngen. Samt att nsta tecken r "="
                    // Fr att undvika fel typ: gustav gustavson

                    if (it->substr(0,name.size()) == name)
                    {
                        // Returnerar frn tecknet efter "=" tecknet och til radens slut
                       name_values->erase (it);



                    }
                }
        }





}

string Config2::findConf(string in)
{
    //Hittar configurationen dr string "in"
    //r lika med allt fre "#"
    string s;
    size_t t;
    vector<string>::iterator it;
    for (it=name_values->begin();it<name_values->end();it++)
        {

            s = *it;
            t = s.find_first_of('#');
            s=s.substr(0,t);

            if (s == in)
                return *it;

        }

        return "nothing";



}

string Config2::stripSokvag(string in)
{
    size_t t = in.find_first_of(".flv=");
    string tmp = in.substr(0,t);
    size_t t2 = tmp.find_last_of('/');
    in=in.substr(t2+1,in.size());
    return in;

}

// Lmnar ut "values" grundade p "name"

string Config2::getConf2(string name)
{

vector<string>::iterator it;
string s;
size_t pos0;
pos0 = name.find("#");
if (pos0 > 0)
   name = name.substr(0,pos0);

for (it=name_values->begin();it<name_values->end();it++)
    {

            if (it->substr(0,1) != "#") // hoppa ver kommaterade rader direkt
            {
                // Sker efter samma delstrng som skickas hit med samma lngd
                // som hitskickade strngen. Samt att nsta tecken r "="
                // Fr att undvika fel typ: gustav gustavson

                if (it->substr(0,name.size()) == name)
                {
                    // Returnerar frn tecknet efter "=" tecknet och til radens slut
                   s = it->substr(name.size(),it->size());

                    return s;

                }
            }
    }
    s="nothing";
    return s;
}

bool Config2::setConf(string name,string value)
{
vector<string>::iterator it;
for (it=name_values->begin();it<name_values->end();it++)
    {

            if (it->substr(0,1) != "#") // hoppa ver kommaterade rader direkt
            {
                // Sker efter strngen "name" som skickas hit med samma lngd
                // som hitskickade strngen. Samt att nsta tecken r "="
                // Fr att undvika fel typ: gustav gustavson
                if ((it->substr(0,name.size()) == name) && (it->substr(name.size(),1) == "="))
                {
                    // Returnerar frn tecknet efter "=" tecknet och til radens slut

                    // "name" har hittats, nu skall nya vrdet lggaas in
                    name.append("=");
                    name.append(value);
                    *it = name;
                    return true;

                }
            }
    }

return false;
}

// En vektor med alla konfigurationsvrden
vector<string>* Config2::getAllConf()
{
    sort(name_values->begin(),name_values->end());
    return name_values;

}

vector<string>* Config2::getAllConf(string filepath)
{
  return readConf2(filepath);

}




void Config2::newConf(string name,string value)
{
    bool ny = dubletConf(name);
    if (ny == true)
    {
    string pair = name+"="+value;
    name_values->push_back(pair);
    }
}

bool Config2::dubletConf(string name)
{

    string tmp;
    vector<string>::iterator it;
    for (it=name_values->begin();it<name_values->end();it++)
    {
              tmp = *it;
              size_t t = tmp.find_first_of('=');
              tmp.resize(t);
              if (name == tmp)
                  return false;
    }

    return true;
}

// Lser configurationsvektorn
bool Config2::readConf(string conf)
{

    name_values = new vector<string>;
    string conf_values;
    ifstream infil;

    infil.open(conf.c_str());
    if (!(infil.good()))
    {
            return false;
    }

    while (getline(infil,conf_values))
    {
        name_values->push_back(conf_values);
    }

    infil.close();
    return true;


}

vector<string>* Config2::readConf2(string conf)
{

    tmp = new vector<string>;
    string conf_values;
    ifstream infil;

    infil.open(conf.c_str());
    if (!(infil.good()))
    {
            return tmp;
    }

    while (getline(infil,conf_values))
    {
        tmp->push_back(conf_values);
    }

    infil.close();
    return tmp;


}



// skriver configurationsvektorn till fil
bool Config2::writeConf()
{
    QString conf_file_name = QDir::toNativeSeparators("/"APPLICATION_NAME".conf");
    k = new Config(conf_file_name);
    string max_downloads = k->getConf("max_downloads");
    stringstream ss;
    ss.clear();
    int imax_downloads=0;
    ss << max_downloads;
    ss >> imax_downloads;

    ofstream utfil;
    utfil.open (conf_file->c_str(),ios::out);
    if (!(utfil.is_open()))
    {
        return false;
    }
    utfil.clear();
    int raknare = 0;
    sort(name_values->begin(),name_values->end());
    vector<string>::reverse_iterator rit;

    for (rit=name_values->rbegin() ; rit < name_values->rend(); ++rit)
    {
        if (raknare < imax_downloads)
        {
          raknare++;
          utfil << *rit;
          utfil << "\n";
        }
    }


    utfil.close();
    delete conf_file;
    return true;

}
// kollar om konfigurationsfilen finns
void Config2::checkConf(string conf)
{
    ifstream infil2;
    infil2.open(conf.c_str());
    infil2.seekg(0,ios::end);
    if (infil2.tellg() < 1)
    {
            infil2.close();
            createConffile(conf);
    }




}
// skapar en default konfigurationsfil
bool Config2::createConffile(string conf)
{
    cr->mkDir();





        ofstream utfil2;
        utfil2.open (conf.c_str(),ios::out);

        if (utfil2.good())
        {




        utfil2.close();

        return true;
        }

        return false;

}
