/*
    Stream Capture
    Copyright (C) 2011 Ingemar Ceicer
    http://ceicer.org/ingemar/
    programmering1 (at) ceicer (dot) org

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
*/

#include "streamcapture.h"
#include "ui_streamcapture.h"

streamCapture::streamCapture(QWidget *parent) :
    QMainWindow(parent),
    ui(new Ui::streamCapture)
{
    setStartConfig();

    connect(ui->getBtn, SIGNAL(released()), this, SLOT(start()));
    connect(ui->actionSearch, SIGNAL(triggered()), this, SLOT(start()));

    connect(ui->downloadBtn, SIGNAL(released()), this, SLOT(download()));
    connect(ui->actionDownload, SIGNAL(triggered()), this, SLOT(download()));

    connect(ui->actionRemoveAll, SIGNAL(triggered()), this, SLOT(removeAll()));
    connect(ui->actionRemoveSelected, SIGNAL(triggered()), this, SLOT(removeSelected()));





    connect(ui->actionExit, SIGNAL(triggered()), this, SLOT(close()));


    connect(ui->menuRecentDownloads, SIGNAL(aboutToShow()), this, SLOT(recentDownloads()));
   // connect(ui->actionClearRecentDownloads, SIGNAL(triggered()), this, SLOT(clearRecentDownloads()));

    connect(ui->actionAbout, SIGNAL(triggered()), this, SLOT(about()));
    connect(ui->actionAboutRPMPDump, SIGNAL(triggered()), this, SLOT(aboutRPMPDump()));
    connect(ui->actionCheckForUpdates, SIGNAL(triggered()), this, SLOT(checkForUpdates()));

    connect(ui->actionSwedish, SIGNAL(triggered()), this, SLOT(swedish()));
    connect(ui->actionEnglish, SIGNAL(triggered()), this, SLOT(english()));

    connect(ui->actionEditDownloadList, SIGNAL(triggered()), this, SLOT(editDownloadList()));


}


// private slots
// Slackware

void streamCapture::hittaRTMPDump(QProcess::ProcessError er  )
{


    if (er == 0)
    {
         const QString s = tr("RTMPDump failed to start. Either the invoked program is missing,\nor you may have insufficient permissions to invoke the program.\n\nSlackware users can download RTMPDump build script from slackbuild.org ")+"<p><a href=\"http://slackbuilds.org/repository/13.1/multimedia/rtmpdump/\">slackbuilds.org</a></p>"+tr("For Windows users RTMPDump is included in the installation of ")+ APPLICATION_NAME;
         QMessageBox mb(this);
         mb.setTextFormat(Qt::RichText);
         mb.setWindowTitle(APPLICATION_NAME);
         mb.setIcon(QMessageBox::Critical);
         mb.setText(s);
         mb.setDefaultButton(QMessageBox::Ok);
         mb.exec();

    }
}

// END Slackvare

void streamCapture::editDownloadList()
{
    Downloads *d = new Downloads;
    d->show();
}

void streamCapture::removeAll()
{
  ui->getLst->clear();
}
void streamCapture::removeSelected()
{
    QListWidgetItem *lwi;
    int a=ui->getLst->currentRow();
    lwi = ui->getLst->takeItem(a);
    delete lwi;


}

void streamCapture::swedish()
{
    QString conf_file_name = QDir::toNativeSeparators("/"APPLICATION_NAME".conf");
    k = new Config(conf_file_name);
    std::string s = k->getConf("language");

    if (s == "nothing")
      {
          k->newConf("language","sv_SE");

      }

    if (s != "sv_SE")
    {
    k->setConf("language","sv_SE");
    QMessageBox::information(this, APPLICATION_NAME " " VERSION,tr("You must restart the application before the language change takes effect."));
    }
    delete k;

}

void streamCapture::english()
{
    QString conf_file_name = QDir::toNativeSeparators("/"APPLICATION_NAME".conf");
    k = new Config(conf_file_name);
    std::string s = k->getConf("language");

    if (s == "nothing")
      {
        k->newConf("language","en_US");

      }

    if (s != "en_US")
    {
    k->setConf("language","en_US");
    QMessageBox::information(this, APPLICATION_NAME " " VERSION,tr("You must restart the application before the language change takes effect."));
    }
    delete k;
}




void streamCapture::downAgain(const int i)
{
    QString conf_file_name2 = QDir::toNativeSeparators("/"APPLICATION_NAME"-recentFiles.conf");
    k2 = new Config2(conf_file_name2);
    std::vector<std::string> *vkt = new std::vector<std::string>;
    vkt = k2->getAllConf();
    delete k2;

    QString valdPost;
    std::string vps = vkt->at(i);
    valdPost = valdPost.fromStdString(vps);
    int pos = valdPost.indexOf('=');
   // QString namn = valdPost.mid(0,pos);
    QString varde = valdPost.mid(pos+1,-1);
   // QMessageBox::information(this,"Test","namn");
   // QMessageBox::information(this,"Test",varde);
    int plats = ui->getLst->count();
   ui->getLst->insertItem(plats+1,varde);

    connect(ui->getLst, SIGNAL(itemClicked(QListWidgetItem *)), this, SLOT(vald(QListWidgetItem *)));

}




void streamCapture::recentDownloads()
{
    QString conf_file_name2 = QDir::toNativeSeparators("/"APPLICATION_NAME"-recentFiles.conf");
    k2 = new Config2(conf_file_name2);
    std::vector<std::string> *vkt = new std::vector<std::string>;
    vkt = k2->getAllConf();
    delete k2;

    QString s, stmp, stid, tid, snamn;
    QDateTime dt;
    int pos0, pos1, pos2;
    ui->menuRecentDownloads->clear();
    int i=0;
    std::vector<std::string>::reverse_iterator rit;






    for (rit=vkt->rbegin() ; rit < vkt->rend(); ++rit)
   {


     QAction *ny = new QAction(ui->menuRecentDownloads);



     s = s.fromStdString(*rit);
     pos0 = s.indexOf('#');
    // QString sss;
    // sss.setNum(pos0);
    // QMessageBox::information(this,"Test",sss);

     if (pos0 < 0)
     {

         pos1 = s.indexOf('=');

       //  stmp = s.mid(pos0+2,pos1-pos0-2);
       //  pos2 = stmp.lastIndexOf('/');
         snamn = s.mid(0,pos1);

         ny->setText(tr("Imported: ")+snamn);


     }
     else
     {
     pos0 = s.indexOf('#');
     pos1 = s.indexOf('=');

     stmp = s.mid(pos0+1,pos1-pos0-1);
     pos2 = stmp.lastIndexOf('/');
     snamn = stmp.mid(pos2+1,-1);
     stid = s.mid(0,pos0);



     uint sec = stid.toInt();
     dt = QDateTime::fromTime_t(sec);
     tid = dt.toString("yyyy-MM-dd hh:mm");

     ny->setText(tid+"  "+snamn);
     }

     ui->menuRecentDownloads->addAction(ny);

     signalMapper = new QSignalMapper;
     signalMapper2 = new QSignalMapper;




     connect(ny, SIGNAL(triggered()), signalMapper, SLOT(map()));
     signalMapper->setMapping(ny, i++);
     connect(signalMapper, SIGNAL(mapped(const int)), this, SLOT(downAgain(const int)));




    }

}
/*
void streamCapture::clearRecentDownloads()
{
    const QString configure_path = QDir::toNativeSeparators(QDir::homePath()+"/."+ APPLICATION_NAME);
    const QString conf_file_name2 = QDir::toNativeSeparators("/"APPLICATION_NAME"-recentFiles.conf");

    //QMessageBox::information(this,"Test",configure_path+conf_file_name2);
    QFile fil;
    bool finns = QFile::exists(configure_path+conf_file_name2);
    if (finns)
    {
        bool bort = fil.remove(configure_path+conf_file_name2);
        if (bort == true)
            QMessageBox::information(this,APPLICATION_NAME " " VERSION,tr("The download history is deleted"));
        if (bort == false)
            QMessageBox::information(this,APPLICATION_NAME " " VERSION,tr("Download history could not be deleted.\nCheck file permissions"));
    }
}
*/
void streamCapture::about()
{
    QString conf_file_name = QDir::toNativeSeparators("/"APPLICATION_NAME".conf");
    k = new Config(conf_file_name);
    std::string s = k->getConf("language");
    delete k;
    QString applicationHomepage;
    if (s == "en_US")
       applicationHomepage = APPLICATION_HOMEPAGE_ENG;
    else
       applicationHomepage = APPLICATION_HOMEPAGE;
    const QString license = tr("Licensierat under GNU General Public License This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version ")+ LICENCE_VERSION +tr(" of the License, or (at your option) any later version. This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details. You should have received a copy of the GNU General Public License along with this program; if not, write to the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.");

    QString auther = "<br><font color=\"green\" size=\"3\"><b>Copyright &copy; "CURRENT_YEAR" "PROGRAMMER_NAME"<br><a href=\"" +applicationHomepage+ "\">" +applicationHomepage+ "</a><br>"PROGRAMMER_EMAIL"<br>"+tr("Phone: ")+PROGRAMMER_PHONE "</b></font><br><br>";

    QMessageBox::about(this, tr("About ")+APPLICATION_NAME+" "+VERSION,tr(
                             "<h1><font color=\"#009900\">")+APPLICATION_NAME+" "+VERSION+"</h1>"+auther+tr("A program to locate media streams and present them to RTMPDump.<br><br>")+license);

}


void streamCapture::aboutRPMPDump()
{
    const QString license = tr("License: GPLv2");
    const QString copyright1 ="Copyright (C) 2009 Andrej Stepanchuk";
    const QString copyright2 ="Copyright (C) 2010 Howard Chu";
    const QString applicationHomepage ="http://rtmpdump.mplayerhq.hu/";
    const QString applicationName ="RTMPDump";
    const QString version="2.3";

    QString auther = tr("<br><font color=\"green\" size=\"3\"><b>")+copyright1+"<br>"+copyright2+"<br><br><a href=\""+applicationHomepage+"\">"+applicationHomepage+"</a></b></font><br><br>";

    QMessageBox::about(this, tr("About ")+applicationName+" "+version,tr(
                             "<h1><font color=\"#009900\">")+applicationName+" "+version+"</h1>"+auther+applicationName+tr(" is a toolkit for RTMP streams. All forms of RTMP are supported, including rtmp://, rtmpt://, rtmpe://, rtmpte://, and rtmps://.<br><br>")+license);


}


void streamCapture::checkForUpdates()
{

    QString conf_file_name = QDir::toNativeSeparators("/"APPLICATION_NAME".conf");
    k = new Config(conf_file_name);
    std::string s = k->getConf("language");
    delete k;
    CheckForUpdates *cfu = new CheckForUpdates;
    cfu->check(s);



}

void streamCapture::output(QNetworkReply *reply)
{


    // Reading attributes of the reply
    // e.g. the HTTP status code
    QVariant statusCodeV1 = reply->attribute(QNetworkRequest::HttpStatusCodeAttribute);
    QString V1 = statusCodeV1.toString();
    QVariant statusCodeV2 = reply->header(QNetworkRequest::ContentTypeHeader);
    QString V2 = statusCodeV2.toString();
    ui->statusBar->showMessage(tr("Status code: ")+V1+tr(" | Header: ")+V2);
    // no error received?
    if (reply->error() == QNetworkReply::NoError)
    {

        // Example 2: Reading bytes form the reply
        QByteArray bytes = reply->readAll();  // bytes
        QString contents = (QString) bytes; // string

        QString contents2 = contents;
        QString contents3 = contents;
        QString contents4 = contents;
        QString contents5 = contents;
        QString out;
        int i=0;
        while (out != "hittasej")
        {
        // rtmp
        out = getStreamEnd(getStream(contents));
        //QMessageBox::information(this,"Test",out);
        if (out != "hittasej")
            {
                ui->getLst->insertItem(i++,out);
                ui->statusBar->showMessage(tr("Status code: ")+V1+tr(" | Header: ")+V2+tr(" | rtmp link detected"));

            }

        }
        if (i == 0)
        {
            // rtmpe
            out="";
            while (out != "hittasej")
            {
            out = getStreamEnd(getStream2(contents2));
            if (out != "hittasej")
                {
                    ui->getLst->insertItem(i++,out);
                    ui->statusBar->showMessage(tr("Status code: ")+V1+tr(" | Header: ")+V2+tr(" | rtmp link detected"));
                }

            }
            if (i == 0)
            {
                // rtmpt
                out="";
                while (out != "hittasej")
                {
                out = getStreamEnd(getStream3(contents3));
                if (out != "hittasej")
                    {
                        ui->getLst->insertItem(i++,out);
                    }

                }
                if (i == 0)
                {
                    // rtmps
                    out="";
                    while (out != "hittasej")
                    {
                    out = getStreamEnd(getStream4(contents4));
                    if (out != "hittasej")
                        {
                            ui->getLst->insertItem(i++,out);
                        }

                    }
                    if (i == 0)
                    {
                        // rtmpte
                        out="";
                        while (out != "hittasej")
                        {
                        out = getStreamEnd(getStream5(contents5));
                        if (out != "hittasej")
                            {
                                ui->getLst->insertItem(i++,out);
                            }

                        }
                        if (i == 0)
                        {
                             ui->statusBar->showMessage(tr("Status code: ")+V1+tr(" | Header: ")+V2+tr(" | No rtmp, rtmpe, rtmpt, rtmpte or rtmps link detected"));



                        }



                    }






                }



            }

        }


    }
    // Some http error received
    else
    {
        ui->statusBar->showMessage(tr("An error occurred"));
        // handle errors here
    }

}

void streamCapture::start()
{
    QString strUrl = ui->urlEdit->text();
    if (strUrl != "")
    {
    connect(ui->getLst, SIGNAL(itemClicked(QListWidgetItem *)), this, SLOT(vald(QListWidgetItem *)));
    // ipac
    //ui->getLst->clear();

    if (strUrl.mid(0,7) != "http://")
         strUrl="http://"+strUrl;
    QUrl url(strUrl);
    nam = new QNetworkAccessManager(this);
    QNetworkReply *reply;
    reply = nam->get(QNetworkRequest(url));


    QObject::connect(nam, SIGNAL(finished(QNetworkReply *)),this, SLOT(output(QNetworkReply *)));
    }
    else
        ui->statusBar->showMessage(tr("Please insert an address!"));
}

void streamCapture::download()
{

    QString conf_file_name = QDir::toNativeSeparators("/"APPLICATION_NAME".conf");
    k = new Config(conf_file_name);
    QString sokvag;
    std::string s = k->getConf("open_path");
    QString qs = QString::fromStdString(s);


    QFileInfo info(qs);
     if (info.isReadable())
           sokvag = qs;
     else
     {
         sokvag = QDir::homePath();
     }

    QFileDialog *dialog = new QFileDialog(this, tr("Save streaming media file"),
                                               sokvag,
                                               tr("Media File (*.flv)"));

    QString in = ui->getLst->currentItem()->text();
    dialog->selectFile(initiallySelected(&in));
    dialog->setAcceptMode(QFileDialog::AcceptSave);
    dialog->setFileMode(QFileDialog::AnyFile);


   if (dialog->exec())
   {
    QStringList fileNames = dialog->selectedFiles();

    if ( (fileNames[0].indexOf("#") != (-1) ) || (fileNames[0].indexOf("=") != (-1) ) )
    {
              QMessageBox::warning(this, APPLICATION_NAME " " VERSION,tr("You may not use the characters\n\"#\" or \"=\" in the file name."));

    }
    else
    {

    QString tmp,tmp2;
    CommProcess = new QProcess();
    if (fileNames[0].right(4) != ".flv" )
    {
       tmp2 = fileNames[0]+".flv";
       tmp = "rtmpdump -r "+in+" -o "+fileNames[0]+".flv";
    }
    else
    {
       tmp2 = fileNames[0];
       tmp = "rtmpdump -r "+in+" -o "+fileNames[0];
    }

    CommProcess->startDetached(tmp);
    QDir dir;
    dir = dialog->directory();
    QString directoryName = dir.path();
    k->setConf("open_path",directoryName.toStdString());
    delete k;

    QDateTime now = QDateTime::currentDateTime();
    uint tid = now.toTime_t();
    QString stid;
    stid.setNum(tid);
    tmp2=stid+"#"+tmp2;


    QString conf_file_name2 = QDir::toNativeSeparators("/"APPLICATION_NAME"-recentFiles.conf");
    k2 = new Config2(conf_file_name2);
    std::string filnamn = tmp2.toStdString();
    std::string streamFilnamn = in.toStdString();
    k2->newConf(filnamn,streamFilnamn);
    delete k2;

    }
    }
    else
       delete k;

}


void streamCapture::vald(QListWidgetItem * item)
{
ui->downloadBtn->setEnabled(true);
ui->actionDownload->setEnabled(true);
ui->statusBar->showMessage(item->text());

}



// private
void streamCapture::setStartConfig()
{

    ui->setupUi(this);

    this->setWindowTitle(APPLICATION_NAME " " VERSION);

    ui->downloadBtn->setDisabled(true);
    ui->actionDownload->setDisabled(true);
    ui->getLst->setContextMenuPolicy(Qt::ActionsContextMenu);
    ui->getLst->addAction(ui->actionRemoveSelected);
    ui->getLst->setSelectionMode(QAbstractItemView::SingleSelection);
   // ui->menuRecentDownloads->setContextMenuPolicy(Qt::CustomContextMenu);

    // Slackware

    process = new QProcess(this);
    process->start("rtmpdump --help");
    //QObject::connect( process, SIGNAL(finished(int,QProcess::ExitStatus)),this, SLOT(hittaRTMPDump(int,QProcess::ExitStatus)));
    QObject::connect( process, SIGNAL(error(QProcess::ProcessError)),this, SLOT(hittaRTMPDump(QProcess::ProcessError)));

    // END Slackware


    QString conf_file_name = QDir::toNativeSeparators("/"APPLICATION_NAME".conf");
    k = new Config(conf_file_name);
    std::stringstream ss;
    std::string s = k->getConf("x_lage");

    int x=0;
    ss << s;
    ss >> x;
    ss.clear();
    s = k->getConf("y_lage");
    int y=0;
    ss << s;
    ss >> y;

    this->setGeometry(x,y,920,338);
    this->setFixedSize(920,338);
    delete k;


}

void streamCapture::setEndConfig()
{
    QString conf_file_name = QDir::toNativeSeparators("/"APPLICATION_NAME".conf");
    k = new Config(conf_file_name);
    QRect rect;
    rect=this->geometry();

    int x_lage=rect.x();
    int y_lage=rect.y();

    std::stringstream ss;
    std::string str;

    ss.clear();

    ss << x_lage;
    ss >> str;
    k->setConf("x_lage",str);

    ss.clear();

    ss << y_lage;
    ss >> str;
    k->setConf("y_lage",str);

    delete k;

}


QString streamCapture::initiallySelected(QString *x)
{
    int i = x->lastIndexOf('/');
    int j = x->lastIndexOf('.');
    QString s = x->mid(i+1,j-i-1);
    s.append(".flv");


return s;

}


QString streamCapture::getStream(QString &contents)
{
    QString hittat;
    int pos = contents.indexOf("rtmp://");

    if (pos < 0)
            {
                    hittat = "hittasej";
                    return hittat;

            }
    //QMessageBox::information(this,"Test","Found rtmp");
    hittat=contents.mid(pos,400);
    contents=contents.remove(0,pos+7);
    return hittat;

}

QString streamCapture::getStream2(QString &contents2)
{
    QString hittat;
    int pos = contents2.indexOf("rtmpe://");

    if (pos < 0)
            {
                    hittat = "hittasej";
                    return hittat;
            }
    //QMessageBox::information(this,"Test","Found rtmpe");
    hittat=contents2.mid(pos,400);
    contents2=contents2.remove(0,pos+8);
    return hittat;

}

QString streamCapture::getStream3(QString &contents3)
{
    QString hittat;
    int pos = contents3.indexOf("rtmpt://");

    if (pos < 0)
            {
                    hittat = "hittasej";
                    return hittat;
            }
    //QMessageBox::information(this,"Test","Found rtmpt");
    hittat=contents3.mid(pos,400);
    contents3=contents3.remove(0,pos+8);
    return hittat;

}

QString streamCapture::getStream4(QString &contents4)
{
    QString hittat;
    int pos = contents4.indexOf("rtmps://");

    if (pos < 0)
            {
                    hittat = "hittasej";
                    return hittat;
            }
    //QMessageBox::information(this,"Test","Found rtmps");
    hittat=contents4.mid(pos,400);
    contents4=contents4.remove(0,pos+8);
    return hittat;

}

QString streamCapture::getStream5(QString &contents5)
{
    QString hittat;
    int pos = contents5.indexOf("rtmpte://");

    if (pos < 0)
            {
                    hittat = "hittasej";
                    return hittat;
            }
    //QMessageBox::information(this,"Test","Found rtmpte");
    hittat=contents5.mid(pos,400);
    contents5=contents5.remove(0,pos+9);
    return hittat;

}

QString streamCapture::getStreamEnd(QString contents)
{
    QString hittat;
    int pos = contents.indexOf(".mp4");
        if (pos < 0)
                {
                        hittat = "hittasej";
                        return hittat;
                }
    hittat=contents.mid(0,pos+4);
    return hittat;

}

streamCapture::~streamCapture()
{

    setEndConfig();
    delete ui;
}
